package com.xxh.cloud.framework.filter;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.servlet.DispatcherType;


@Configuration
@ConditionalOnProperty(value ="biz.filter.enabled", havingValue = "true")
public class BizFilterConfig {


    @Bean
    public FilterRegistrationBean sqlFilterRegistration() {
        //System.out.println("+++++++++++++++++++++++sqlFilter  SQL");
        FilterRegistrationBean registration = new FilterRegistrationBean();
        registration.setDispatcherTypes(DispatcherType.REQUEST);
        registration.setFilter(new SqlFilter());
        registration.addUrlPatterns("/*");
        registration.setName("sqlFilter");
        registration.setOrder(2);
        return registration;
    }

}
