package com.xxh.cloud.framework.filter;

import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.xss.SqlFilterUtils;
import com.xxh.cloud.framework.security.intercepter.WebHttpServletRequestWrapper;
import org.springframework.http.HttpMethod;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

public class SqlFilter implements Filter {
    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        //System.out.println("----------执行SqlFilter");

        HttpServletResponse httpResponse=(HttpServletResponse) response;
        HttpServletRequest httpServletRequest = (HttpServletRequest) request;

        String contentType = httpServletRequest.getContentType();
        String method = httpServletRequest.getMethod();


        if(!HttpMethod.POST.name().toUpperCase().equals(method.toUpperCase())){
            chain.doFilter(request, response);
            return;
        }

        if(contentType.indexOf("json")<0){
            chain.doFilter(request, response);
            return;
        }

        WebHttpServletRequestWrapper requestWrapper = null;

        try {
            requestWrapper = new WebHttpServletRequestWrapper(httpServletRequest);
            String bodyContent = requestWrapper.getBodyContent();
            SqlFilterUtils.sqlInject(bodyContent);
            requestWrapper.setBodyContent(bodyContent);
        }catch (Exception e){
            e.printStackTrace();
            //httpResponse.setStatus(401);
            httpResponse.setStatus(200);
            httpResponse.setContentType("application/json;charset=UTF-8");
            httpResponse.setCharacterEncoding("utf-8");
            Result<String> result = new Result<String>().error(BusinessBaseErrorEnum.INVALID_SYMBOL);
            httpResponse.getWriter().write(JSONObject.toJSONString(result));
            return;
        }

        if (requestWrapper == null) {
            chain.doFilter(request, response);
        } else {
            chain.doFilter(requestWrapper, response);
        }


    }
}
