package com.xxh.cloud.framework.security;

/**
 * @Author: limj
 * @Date: 2023/11/29
 */

import com.alibaba.fastjson2.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.security.utils.SecurityUtils;
import lombok.SneakyThrows;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.MethodParameter;
import org.springframework.http.MediaType;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.servlet.mvc.method.annotation.ResponseBodyAdvice;

/**
 * 拦截controller返回值，封装后统一返回格式
 */
@Log4j2
@RestControllerAdvice
public class ResponseAdvice implements ResponseBodyAdvice<Object> {

//    @Autowired
//    private ObjectMapper objectMapper;

    @Override
    public boolean supports(MethodParameter returnType, Class converterType) {
        return true;
    }

    @SneakyThrows
    @Override
    public Object beforeBodyWrite(Object o, MethodParameter returnType, MediaType selectedContentType, Class selectedConverterType, ServerHttpRequest request, ServerHttpResponse response) {
        //如果Controller返回String的话，SpringBoot不会帮我们自动封装而直接返回，因此我们需要手动转换成json。
        if (o instanceof Result) {
            Result result = (Result) o;
            result.setData(SecurityUtils.encryptBaseResultData(result.getData()));
            return result;
        } else {
            return o;
        }
    }
}

