package com.xxh.cloud.framework.security.utils;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.digest.DigestUtil;

public class CacheKeys {

    public static String getUserToken() {
        return StrUtil.format("AUK_{}", IdUtil.getSnowflake(1, 1).nextIdStr());
    }

    public static String getUserIdCacheKey(String id) {
        return "UTK_" + id;
    }


    public static String RsaPubPriKey="RSA:K:PP";


    /**
     *  RSA Key
     *  @param tonken
     *  @param  isUserKey :是否每个用户一个证书
     * */
    public static String getRsaKey(String tonken,boolean isUserKey){
        if(!isUserKey){
            return CacheKeys.RsaPubPriKey;
        }
        if(StrUtil.isEmpty(tonken)){
            return CacheKeys.RsaPubPriKey;
        }
        String md5Str= DigestUtil.md5Hex(tonken);
        return StrUtil.format("RSA:K:{}",md5Str.toUpperCase());
    }


    /**
     * RSA Key （全局统一证书）
     * */
    public static String getRsaKey(){
        return getRsaKey(null,false);
    }

    /**
     * RSA Key （一人一证）
     * */
    public static String getRsaKey(String tonken){
        return getRsaKey(tonken,true);
    }



}
