package com.xxh.cloud.framework.common.mybatisplus.config;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.plugins.handler.TableNameHandler;

import java.util.Arrays;
import java.util.List;

public class DynamicTableNameHandler implements TableNameHandler {



    private static  final  ThreadLocal<String> TableNameSuffix=new ThreadLocal<>();

    private List<String> tableNames;

    public DynamicTableNameHandler(){

    }

    public DynamicTableNameHandler(String ... tableNames){
        this.tableNames= Arrays.asList(tableNames);
    }


    public static void setTableNameSuffix(String ym){
        TableNameSuffix.set(ym);
    }


    public static String getTableNameSuffix(){
        return TableNameSuffix.get();
    }


    public static void removeTableNameSuffix(){
        TableNameSuffix.remove();
    }

    @Override
    public String dynamicTableName(String sql, String tableName) {

//        System.out.println("***************TableNameHandler2**************");
//        System.out.println("------------SQL");
//        System.out.println(sql);
//
//        System.out.println("------------tableName");
//        System.out.println(tableName);

        if(this.tableNames.contains(tableName)){
            String suffix=TableNameSuffix.get();
            if(StrUtil.isEmpty(suffix)){
                return tableName;
            }else {
                TableNameSuffix.remove();
                return tableName+"_"+suffix;
            }
        }else {
            return tableName;
        }

    }




}
