package com.xxh.cloud.framework.common.mybatisplus.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.xxh.cloud.framework.common.user.LoginUser;
import com.xxh.cloud.framework.common.user.AuthContextUtils;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class MyMetaObjectHandler implements MetaObjectHandler {


    private final static String CREATE_DATE = "createDate";
    private final static String CREATOR = "creator";

    private final static String UPDATE_DATE = "updateDate";

    private final static String UPDATER = "updater";

    private final static String DEPT_ID = "deptId";



    @Override
    public void insertFill(MetaObject metaObject) {
        LoginUser user= AuthContextUtils.getCurrentLoginUser();
        Date date = new Date();

        if(user!=null){
            //创建者
            this.strictInsertFill(metaObject, CREATOR, String.class, user.getId());
            //创建者所属部门
            //this.strictInsertFill(metaObject, DEPT_ID, String.class, user.getDeptId());
            //更新者
            this.strictInsertFill(metaObject, UPDATER, String.class, user.getId());
        } else {
            this.strictInsertFill(metaObject, CREATOR, String.class, "sys");
            this.strictInsertFill(metaObject, UPDATER, String.class, "sys");
        }

        //创建时间
        this.strictInsertFill(metaObject, CREATE_DATE, Date.class, date);
        //更新时间
        this.strictInsertFill(metaObject, UPDATE_DATE, Date.class, date);

    }

    @Override
    public void updateFill(MetaObject metaObject) {
        LoginUser user= AuthContextUtils.getCurrentLoginUser();
        Date date = new Date();
        //更新者
        if(user!=null){
            this.strictInsertFill(metaObject, UPDATER, String.class, user.getId());
        }else {
            this.strictInsertFill(metaObject, UPDATER, String.class, "sys");
        }
        //更新时间
        this.strictInsertFill(metaObject, UPDATE_DATE, Date.class, date);
    }


}
