package com.xxh.cloud.framework.common.mybatisplus.page;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.xxh.cloud.framework.common.page.PageData;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * mybatisplus
 * */
public abstract class PageConverter <R,T> {


    public abstract T converter(R entity);

    public PageData<T> getPageData(IPage<R> page){
        if(page==null){
            return null;
        }
        return this.getPageData(page.getRecords(),page.getTotal(),page.getSize(),page.getPages());
    }

    public  PageData<T> getPageData(List<R> list, long total, long size,long pages){
        List<T> targetList = this.sourceToTarget(list);
        return new PageData<T>(targetList, total, size, pages);
    }

    public  List<T> sourceToTarget(Collection<R> sourceList){
        if(sourceList == null){
            return null;
        }
        List<T> targetList = new ArrayList<>();
        if(CollUtil.isEmpty(sourceList)){
            return targetList;
        }
        for(R source : sourceList){
             T targetObject = this.converter(source);
             targetList.add(targetObject);
        }
        return targetList;
    }


//    public static void main(String[] args) {
//        List<PageOneBean> oneList=new ArrayList<>();
//        oneList.add(new PageOneBean("1"));
//        oneList.add(new PageOneBean("2"));
//
//        PageData<PageTwoBean> data=
//        new PageConverter<PageOneBean, PageTwoBean>() {
//            @Override
//            public PageTwoBean converter(PageOneBean entity) {
//                return new PageTwoBean(entity.getId());
//            }
//        }.getPageData(oneList,2);
//
//
//        System.out.println(JSON.toJSONString(data));
//
//    }



}
