package com.xxh.cloud.framework.script.modules.biz.bean.dto;

import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.script.modules.biz.constant.enums.TableDataTypeEnum;
import com.xxh.cloud.framework.script.modules.biz.constant.enums.TableColumnBaseEnum;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class EntityDDLCreatePropertyDTO {

    /**
     *  字段名称
     * */
    private String name;

    /**
     * 字段编号
     * */
    private String code;

    /**
     * 字段数据类型
     * */
    private String dataType;


    /**
     * 字段数据类型长度
     * */
    private int dataTypeSize;

    /**
     *  是否主健
     * */
    private String priKey;

    /**
     * 隐藏 -del
     * */
    private String hidden;


    public EntityDDLCreatePropertyDTO(String code, String name, TableDataTypeEnum dataType, int dataTypeSize, YN priKey){
            this.code=code;
            this.name=name;
            this.dataType=dataType.getCode();
            this.dataTypeSize=dataTypeSize;
            this.priKey=priKey.getCode();
    }

    public EntityDDLCreatePropertyDTO(String code, String name, TableDataTypeEnum dataType, int dataTypeSize){
        this.code=code;
        this.name=name;
        this.dataType=dataType.getCode();
        this.dataTypeSize=dataTypeSize;
        this.priKey=YN.NO.getCode();
    }

    public EntityDDLCreatePropertyDTO(String code, String name, TableDataTypeEnum dataType){
        this.code=code;
        this.name=name;
        this.dataType=dataType.getCode();
        this.dataTypeSize=0;
        this.priKey=YN.NO.getCode();
    }

    public EntityDDLCreatePropertyDTO(String code, String name, String dataType){
        this.code=code;
        this.name=name;
        this.dataType=dataType;
        this.dataTypeSize=0;
        this.priKey=YN.NO.getCode();
    }

    /**
     * 基础定义
     * */
    public EntityDDLCreatePropertyDTO(TableColumnBaseEnum tableColumnBaseEnum){
        this.code= tableColumnBaseEnum.getCode();
        this.name= tableColumnBaseEnum.getName();
        this.dataType= tableColumnBaseEnum.getType().getCode();
        this.dataTypeSize=0;
        this.priKey=YN.NO.getCode();
    }

    /**
     * 基础定义
     * */
    public EntityDDLCreatePropertyDTO(TableColumnBaseEnum tableColumnBaseEnum, int dataTypeSize, YN priKey){
        this.code= tableColumnBaseEnum.getCode();
        this.name= tableColumnBaseEnum.getName();
        this.dataType= tableColumnBaseEnum.getType().getCode();
        this.dataTypeSize=dataTypeSize;
        this.priKey=priKey.getCode();
    }

    public EntityDDLCreatePropertyDTO(){

    }



}
