package com.xxh.cloud.framework.script.modules.biz.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.constant.DataSourceTypeEnum;
import com.xxh.cloud.framework.script.modules.biz.bean.vos.TableEntityPropertyVO;
import com.xxh.cloud.framework.script.modules.biz.bean.vos.TableEntityVO;
import com.xxh.cloud.framework.script.modules.biz.mapper.DbSqlDDLMapper;
import com.xxh.cloud.framework.script.modules.biz.service.DbTableSchemaApiService;
import com.xxh.cloud.framework.script.modules.sql.ddl.SqlDDLUtils;
import com.xxh.cloud.framework.script.modules.sql.ddl.convert.DataTypeConvertFactory;
import com.xxh.cloud.framework.script.modules.sql.ddl.convert.ITypeConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DbTableSchemaApiServiceImpl implements DbTableSchemaApiService {


    @Autowired
    private DbSqlDDLMapper dbSqlDDLMapper;

    @Override
    public List<TableEntityVO> getTableList(DataSourceTypeEnum dataSourceType, String database) {
        String sql= SqlDDLUtils.getTabel2DBSQL(dataSourceType,database);
        List<TableEntityVO> list = dbSqlDDLMapper.entityList(sql);
        return list;
    }

    @Override
    public List<TableEntityVO> getTableLikeList(DataSourceTypeEnum dataSourceType, String database, String likeTableCode) {
        String sql= SqlDDLUtils.getTabel2DBLikeSQL(dataSourceType,database,likeTableCode);
        System.out.println(" +++++ " + sql);
        List<TableEntityVO> list = dbSqlDDLMapper.entityList(sql);
        return list;
    }

    @Override
    public TableEntityVO getTableInfo(DataSourceTypeEnum dataSourceType, String database, String tableCode) {
        String sql= SqlDDLUtils.getTabel2DBSQL(dataSourceType,database,tableCode);
        TableEntityVO entityModel= dbSqlDDLMapper.getEntityObj(sql);
        return entityModel;
    }

    @Override
    public List<TableEntityPropertyVO> getTableColumns(DataSourceTypeEnum dataSourceType, String database, String tableCode) {
        String sql= SqlDDLUtils.getColumn2TableSQL(dataSourceType,database,tableCode);
        List<TableEntityPropertyVO> list= dbSqlDDLMapper.entityPropList(sql);

        if(CollUtil.isNotEmpty(list)){
            ITypeConvert convert= DataTypeConvertFactory.getConvertTypeFactory(dataSourceType);
            for(TableEntityPropertyVO propertyVO:list){
                propertyVO.setEntityDataType(convert.getEntityDataType(propertyVO.getType()));
            }
        }
        return list;
    }




}
