package com.xxh.cloud.framework.script.modules.db.service.impl;

import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.script.modules.db.service.DBInsertOpApi;
import com.xxh.cloud.framework.script.modules.db.util.DbSQLExecuteUtils;
import com.xxh.cloud.framework.script.modules.error.DBErrorEnum;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;

public class DBInsertOpService implements DBInsertOpApi {


    /**
     *
     * */
    @Override
    public int insert(Connection connection, String sql) {
        return  DbSQLExecuteUtils.execute(connection,sql);
    }

    @Override
    public int insert(DataSource dataSource, String sql) {
        Connection connection=null;
        try {
            connection = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }

        return insert(connection,sql);
    }

    @Override
    public int insert(Connection connection, String sql, Map<String, Object> paramMap) {
        return  DbSQLExecuteUtils.execute(connection,sql,paramMap);
    }

    @Override
    public int insert(DataSource dataSource, String sql, Map<String, Object> paramMap) {
        Connection connection=null;
        try {
            connection = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }
        return insert(connection,sql,paramMap);
    }

    @Override
    public int[] insertBatch(Connection connection, String sql, List<Object[]> paramsBatch) {
        return DbSQLExecuteUtils.executeBatch(connection,sql,paramsBatch);
    }

    @Override
    public int[] insertBatch(DataSource dataSource, String sql, List<Object[]> paramsBatch) {
        Connection connection=null;
        try {
            connection = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }
        return insertBatch(connection,sql,paramsBatch);
    }

    @Override
    public int[] executeBatch(Connection connection, List<String> sqls) {
        return DbSQLExecuteUtils.executeBatch(connection,sqls);
    }

    @Override
    public int[] executeBatch(DataSource dataSource, List<String> sqls) {
        Connection connection=null;
        try {
            connection = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }
        return executeBatch(connection,sqls);
    }


}
