package com.xxh.cloud.framework.script.modules.db.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.lang.Dict;
import cn.hutool.db.Entity;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.script.modules.db.service.DBSelectOpApi;
import com.xxh.cloud.framework.script.modules.db.util.DbSQLExecuteUtils;
import com.xxh.cloud.framework.script.modules.error.DBErrorEnum;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DBSelectOpService implements DBSelectOpApi {



//    String sql="INSERT INTO hs_form_config_info(id ,name) VALUES (?,?)";
//    List<Object[]> paramsBatch=new ArrayList<>();
//    List<Object> list1 = new ArrayList<>();
//        list1.add("100");
//        list1.add("AAAA");
//        paramsBatch.add( Convert.toStrArray(list1));
//
//    List<Object> list2 = new ArrayList<>();
//        list2.add("200");
//        list2.add(null);
//        paramsBatch.add(Convert.toStrArray(list2));
//        DbSQLExecuteUtils.executeBatch(conn,sql,paramsBatch);









    /**
     * select:
     * */
    @Override
    public List<Map<String, Object>> selectList(DataSource dataSource, String sql) {
        Connection conn=null;
        try {
            conn = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }
        return this.selectList(conn,sql);
    }

    @Override
    public List<Dict> selectListDict(DataSource dataSource, String sql) {
        Connection conn=null;
        try {
            conn = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }
        return this.selectListDict(conn,sql);
    }



    @Override
    public List<Map<String, Object>> selectList(Connection connection, String sql) {
        List<Map<String, Object>> data=new ArrayList<>();
        List<Entity> list= DbSQLExecuteUtils.queryList(connection,sql);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        for (Entity entity:list) {
            Map<String, Object> dataItem=new HashMap<>();
            for (String key:entity.keySet()){
                dataItem.put(key,entity.get(key));
            }
            data.add(dataItem);
        }
        return data;
    }

    @Override
    public List<Dict> selectListDict(Connection connection, String sql) {
        List<Dict> data=new ArrayList<>();
        List<Entity> list= DbSQLExecuteUtils.queryList(connection,sql);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        for (Entity entity:list) {
            Dict dataItem= Dict.create();
            for (String key:entity.keySet()){
                dataItem.put(key,entity.get(key));
            }
            data.add(dataItem);
        }

        return data;
    }


    @Override
    public <T> List<T> selectListBean(DataSource dataSource, String sql, Class<T> beanType) {
        Connection conn=null;
        try {
            conn = dataSource.getConnection();
        }catch (SQLException e){
            e.printStackTrace();
            throw new BusinessException(DBErrorEnum.DB_Connection,"获取数据库连接错误");
        }
        return this.selectListBean(conn,sql,beanType);
    }


    @Override
    public <T> List<T> selectListBean(Connection connection, String sql,Class<T> beanType) {
        List<T> data = DbSQLExecuteUtils.queryListBean(connection,sql,beanType);
        return data;
    }









}
