package com.xxh.cloud.framework.script.modules.sql.ddl.convert;


import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.script.modules.biz.constant.enums.TableDataTypeEnum;

public class MySQLTypeConvert implements ITypeConvert {
    @Override
    public String getDataType(String dataType, int dataTypeSize) {
        if(TableDataTypeEnum.MT_Int.getCode().equals(dataType)){
            return "INT";
        }else if(TableDataTypeEnum.MT_Decimal.getCode().equals(dataType)){
            return "DECIMAL(11,4) ";
        }else if(TableDataTypeEnum.MT_DateTime.getCode().equals(dataType)){
            return "DATETIME";
        }else if(TableDataTypeEnum.MT_Dict.getCode().equals(dataType)){
            return "VARCHAR(64)";
        }else if(TableDataTypeEnum.MT_String.getCode().equals(dataType)){
            return "VARCHAR(256)";
        }else if(TableDataTypeEnum.MT_Text.getCode().equals(dataType)){
            return "VARCHAR(1024)";
        }
        return "VARCHAR(64)";
    }



    @Override
    public String getEntityDataType(String dbDataType) {
        if(StrUtil.isEmpty(dbDataType)){
            return null;
        }
        if("varchar".equals(dbDataType.toLowerCase())){
            return TableDataTypeEnum.MT_String.getCode();
        }else if("datetime".equals(dbDataType.toLowerCase())){
            return TableDataTypeEnum.MT_DateTime.getCode();
        }else if("date".equals(dbDataType.toLowerCase())){
            return TableDataTypeEnum.MT_DateTime.getCode();
        }else if("int".equals(dbDataType.toLowerCase())){
            return TableDataTypeEnum.MT_Int.getCode();
        }



        return TableDataTypeEnum.MT_String.getCode();
    }

    public static void main(String[] args) {
        String s="AbC";
        System.out.println(s.toLowerCase());
    }
}
