package com.xxh.cloud.framework.script.modules.sql.operate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.script.modules.sql.operate.bean.UpdateBean;
import com.xxh.cloud.framework.script.modules.sql.operate.bean.WhereAndOrBean;
import com.xxh.cloud.framework.script.modules.sql.operate.script.SqlConvertByType;
import com.xxh.cloud.framework.script.modules.sql.operate.script.WhereWrapper;

import java.util.ArrayList;
import java.util.List;

public class UpdateSqlWrapper implements ISqlWrapper{

    private String tableName;
    private List<UpdateBean> updates;
    private List<WhereAndOrBean> wheres;



    public UpdateSqlWrapper update(String tableName){
        this.tableName=tableName;
        return this;
    }

    public UpdateSqlWrapper Set(List<UpdateBean> updates){
        this.updates=updates;
        return this;
    }

    public UpdateSqlWrapper where(List<WhereAndOrBean> wheres){
        this.wheres=wheres;
        return this;
    }

    public UpdateSqlWrapper where(WhereAndOrBean where){
        if(this.wheres==null){
            this.wheres=new ArrayList<>();
        }
        if(where!=null){
            this.wheres.add(where);
        }
        return this;
    }

    private void check() throws BusinessException {
        if(StrUtil.isEmpty(this.tableName)){
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"表名不能为空");
        }
        if(CollUtil.isEmpty(this.updates)){
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"更新字段不能为空");
        }
//        if(CollUtil.isEmpty(this.wheres)){
//            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"");
//        }

    }

    @Override
    public String getSqlSegment(){
        this.check();
        StringBuilder sql=new StringBuilder();
        sql.append(" Update ").append(this.tableName).append(" set ");
        boolean isOne=true;
        for(UpdateBean entity:this.updates){
            if(isOne){
                isOne=false;
            }else{
                sql.append(" , ");
            }
            sql.append(entity.getP()).append(" = ").append(SqlConvertByType.convert(entity.getT(),entity.getV()));
        }
        if(CollUtil.isNotEmpty(this.wheres)){
            sql.append(" where ").append(new WhereWrapper(this.wheres).getSqlSegment());
        }
        return  sql.toString();
    }

}
