package com.xxh.cloud.framework.script.modules.sql.operate.script;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.XXEnumUtil;
import com.xxh.cloud.framework.script.modules.sql.operate.bean.WhereItemBean;
import com.xxh.cloud.framework.script.modules.sql.operate.constant.ConditionOp;

import java.util.List;

public class ConditionWrapper {


    public static String getSqlSegment(WhereItemBean entity){
        ConditionOp op = XXEnumUtil.getEnum(ConditionOp.class,entity.getOp());

        switch (op){
            case EQ:
                return ConditionWrapper.eq(entity);
            case NE:
                return ConditionWrapper.ne(entity);
            case GT:
                return ConditionWrapper.gt(entity);
            case GE:
                return ConditionWrapper.ge(entity);
            case LT:
                return ConditionWrapper.lt(entity);
            case LE:
                return ConditionWrapper.le(entity);
            case Between:
                return ConditionWrapper.between(entity);
            case NotBetween:
                return ConditionWrapper.notBetween(entity);
            case Like:
                return ConditionWrapper.like(entity);
            case NotLike:
                return ConditionWrapper.notLike(entity);
            case IsNull:
                return ConditionWrapper.isNull(entity);
            case IsNotNull:
                return ConditionWrapper.isNotNull(entity);
            case In:
                return ConditionWrapper.in(entity);
            case NotIn:
                return ConditionWrapper.notIn(entity);

        }
        return  "";
    }




    /**
     *  eq
     * */
    public static String eq(WhereItemBean entity){
        return ConditionWrapper.eq(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVd(),
                entity.getVp()
        );
    }


    public static String eq(String table,String column,String dataType,String val,String vtable,String vcolumn){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{}.{} = {}.{}",table,column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{}.{} = {}",table,column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }else{
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{} = {}.{}",column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{} = {}",column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }

    }



    /**
     *  ne
     * */
    public static String ne(WhereItemBean entity){
        return ConditionWrapper.ne(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVd(),
                entity.getVp()
        );
    }


    public static String ne(String table,String column,String dataType,String val,String vtable,String vcolumn){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{}.{} <> {}.{}",table,column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{}.{} <> {}",table,column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{} <> {}.{}",column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{} <> {}",column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }

    }


    /**
     * gt
     * */
    public static String gt(WhereItemBean entity){
        return ConditionWrapper.gt(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVd(),
                entity.getVp()
        );
    }



    public static String gt(String table,String column,String dataType,String val,String vtable,String vcolumn){

        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{}.{} > {}.{}",table,column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{}.{} > {}",table,column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{} > {}.{}",column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{} > {}",column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }

    }


    /**
     * ge
     * */
    public static String ge(WhereItemBean entity){
        return ConditionWrapper.ge(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVd(),
                entity.getVp()
        );
    }


    public static String ge(String table,String column,String dataType,String val,String vtable,String vcolumn){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{}.{} >= {}.{}",table,column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{}.{} >= {}",table,column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{} >= {}.{}",column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{} >= {}",column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }

    }


    /**
     * lt
     * */
    public static String lt(WhereItemBean entity){
        return ConditionWrapper.lt(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVd(),
                entity.getVp()
        );
    }


    public static String lt(String table,String column,String dataType,String val,String vtable,String vcolumn){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{}.{} < {}.{}",table,column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{}.{} < {}",table,column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{} < {}.{}",column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{} < {}",column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }

    }

    /**
     * le
     * */
    public static String le(WhereItemBean entity){
        return ConditionWrapper.le(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVd(),
                entity.getVp()
        );
    }



    public static String le(String table,String column,String dataType,String val,String vtable,String vcolumn){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{}.{} <= {}.{}",table,column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{}.{} <= {}",table,column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(vtable) && StrUtil.isNotEmpty(vcolumn)){
                return StrUtil.format("{} <= {}.{}",column,vtable,vcolumn);
            }else if(val!=null){
                return StrUtil.format("{} <= {}",column, SqlConvertByType.convert(dataType,val));
            }else{
                return "";
            }
        }

    }



    /**
     * between
     * */
    public static String between(WhereItemBean entity){
        return ConditionWrapper.between(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVv()
        );
    }


    public static String between(String table,String column,String dataType,String val,String vval){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(val) && StrUtil.isNotEmpty(vval)){
                return StrUtil.format("{}.{}  between {} and {}",table,column,
                        SqlConvertByType.convert(dataType,val),
                        SqlConvertByType.convert(dataType,vval)
                );
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(val) && StrUtil.isNotEmpty(vval)){
                return StrUtil.format("{}  between {} and {}",column,
                        SqlConvertByType.convert(dataType,val),
                        SqlConvertByType.convert(dataType,vval)
                );
            }else{
                return "";
            }
        }

    }



    /**
     * notBetween
     * */
    public static String notBetween(WhereItemBean entity){
        return ConditionWrapper.notBetween(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV(),
                entity.getVv()
        );
    }


    public static String notBetween(String table,String column,String dataType,String val,String vval){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(val) && StrUtil.isNotEmpty(vval)){
                return StrUtil.format("{}.{}  not between {} and {}",table,column,
                        SqlConvertByType.convert(dataType,val),
                        SqlConvertByType.convert(dataType,vval)
                );
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(val) && StrUtil.isNotEmpty(vval)){
                return StrUtil.format("{}  not between {} and {}",column,
                        SqlConvertByType.convert(dataType,val),
                        SqlConvertByType.convert(dataType,vval)
                );
            }else{
                return "";
            }
        }

    }


    /**
     * like
     * */
    public static String like(WhereItemBean entity){
        return ConditionWrapper.like(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV()
        );
    }

    public static String like(String table, String column, String dataType,String val){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(val)){
                return StrUtil.format("{}.{} like {}",table,column, SqlConvertByType.convertLike(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(val)){
                return StrUtil.format("{} like {}",column, SqlConvertByType.convertLike(dataType,val));
            }else{
                return "";
            }
        }
    }


    /**
     * NotLike
     * */
    public static String notLike(WhereItemBean entity){
        return ConditionWrapper.notLike(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getV()
        );
    }


    public static String notLike(String table,String column,String dataType,String val){
        if(StrUtil.isNotEmpty(table)){
            if(StrUtil.isNotEmpty(val)){
                return StrUtil.format("{}.{} not like {}",table,column, SqlConvertByType.convertLike(dataType,val));
            }else{
                return "";
            }
        }else {
            if(StrUtil.isNotEmpty(val)){
                return StrUtil.format("{} not like {}",column, SqlConvertByType.convertLike(dataType,val));
            }else{
                return "";
            }
        }

    }

    /**
     * isNull
     * */
    public static String isNull(WhereItemBean entity){
        return ConditionWrapper.isNull(entity.getD(),
                entity.getP());
    }



    public static String isNull(String table,String column){
        if(StrUtil.isNotEmpty(table)){
            return StrUtil.format("{}.{} is null",table,column);
        }else {
            return StrUtil.format("{} is null",column);
        }
    }



    /**
     * isNotNull
     * */
    public static String isNotNull(WhereItemBean entity){
        return ConditionWrapper.isNotNull(entity.getD(),
                entity.getP());
    }



    public static String isNotNull(String table,String column){
        if(StrUtil.isNotEmpty(table)){
            return StrUtil.format("{}.{} is not null",table,column);
        }else {
            return StrUtil.format("{} is not null",column);
        }

    }




    /**
     * in
     * */
    public static String in(WhereItemBean entity){
        return ConditionWrapper.in(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getVs());
    }


    public static String in(String table, String column, String dataType, List<String> vals){
        if(StrUtil.isNotEmpty(table)){
            if(CollUtil.isNotEmpty(vals)){
                return StrUtil.format("{}.{} in {}",table,column,SqlConvertByType.convertIn(dataType,vals));
            }else{
                return "";
            }
        }else {
            if(CollUtil.isNotEmpty(vals)){
                return StrUtil.format("{} in {}",column,SqlConvertByType.convertIn(dataType,vals));
            }else{
                return "";
            }
        }
    }



    /**
     * not in
     * */
    public static String notIn(WhereItemBean entity){
        return ConditionWrapper.notIn(entity.getD(),
                entity.getP(),
                entity.getT(),
                entity.getVs());
    }


    public static String notIn(String table,String column,String dataType,List<String> vals){
        if(StrUtil.isNotEmpty(table)){
            if(CollUtil.isNotEmpty(vals)){
                return StrUtil.format("{}.{} not in {}",table,column,SqlConvertByType.convertIn(dataType,vals));
            }else{
                return "";
            }
        }else {
            if(CollUtil.isNotEmpty(vals)){
                return StrUtil.format("{} not in {}",column,SqlConvertByType.convertIn(dataType,vals));
            }else{
                return "";
            }
        }

    }


}
