package com.xxh.cloud.framework.script.modules.sql.operate.script;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.script.modules.sql.operate.ISqlWrapper;
import com.xxh.cloud.framework.script.modules.sql.operate.bean.OrderByBean;

import java.util.List;

public class OrderByWrapper implements ISqlWrapper {

    private List<OrderByBean> orderBy;

    public OrderByWrapper(List<OrderByBean> orderBy){
        this.orderBy=orderBy;
    }

    private String getOrderBySQL(OrderByBean entity){
        if(StrUtil.isNotEmpty(entity.getD())){
            return StrUtil.format("{}.{} {}",entity.getD(),entity.getP(),entity.getT());
        }else {
            return StrUtil.format("{} {}",entity.getP(),entity.getT());
        }
    }



    @Override
    public String getSqlSegment() {
        boolean isOne=true;
        StringBuilder sql=new StringBuilder();
        if(CollUtil.isNotEmpty(this.orderBy)){
            for(OrderByBean obb:this.orderBy){
                if(isOne){
                    isOne=false;
                    sql.append(" order by ").append(this.getOrderBySQL(obb));
                }else{
                    sql.append(" , ").append(this.getOrderBySQL(obb));
                }
            }
        }
        return sql.toString();

    }


}
