package com.xxh.cloud.framework.script.modules.sql.operate.script;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.script.modules.sql.operate.ISqlWrapper;
import com.xxh.cloud.framework.script.modules.sql.operate.bean.SelectBean;
import com.xxh.cloud.framework.script.modules.sql.operate.constant.FnTypeEnum;

import java.util.List;

public class SelectWrapper implements ISqlWrapper {


    private List<SelectBean> select;

    public SelectWrapper(List<SelectBean> select){
        this.select=select;
    }


    private String getSelectItemSQL(SelectBean bean){
        StringBuilder sql=new StringBuilder();

        if(StrUtil.isEmpty(bean.getF()) || FnTypeEnum.FN_None.getCode().equals(bean.getF())){
            sql.append(this.getSelectColumnSql(bean.getD(),bean.getP()));
        }else {
            sql.append(this.getFun(bean.getF(),bean.getD() ,bean.getP()));
        }

        if(StrUtil.isNotEmpty(bean.getAs())){
            sql.append(" as ").append(bean.getAs());
        }
        return  sql.toString();
    }


    private String  getFun(String f,String d,String p){
        if(FnTypeEnum.FN_None.getCode().equals(f)){
            return this.getSelectColumnSql(d,p);
        }else if(FnTypeEnum.FN_Count.getCode().equals(f)){
            return  StrUtil.format("COUNT({})",this.getSelectColumnSql(d,p));
        }else if(FnTypeEnum.FN_Max.getCode().equals(f)){
            return StrUtil.format("MAX({})",this.getSelectColumnSql(d,p));
        }else if(FnTypeEnum.FN_Min.getCode().equals(f)){
            return StrUtil.format("MIN({})",this.getSelectColumnSql(d,p));
        }else if(FnTypeEnum.FN_Avg.getCode().equals(f)){
            return StrUtil.format("AVG({})",this.getSelectColumnSql(d,p));
        }else if(FnTypeEnum.FN_Sum.getCode().equals(f)){
            return StrUtil.format("SUM({})",this.getSelectColumnSql(d,p));
        }else if(FnTypeEnum.FN_Abs.getCode().equals(f)){
            return StrUtil.format("ABS({})",this.getSelectColumnSql(d,p));
        }else if(FnTypeEnum.FN_Len.getCode().equals(f)){
            return StrUtil.format("LENGTH({})",this.getSelectColumnSql(d,p));
        }else {
            throw new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR,"不支持的函数配置");
        }
    }

    private String getSelectColumnSql(String d,String p){
        StringBuilder str = new StringBuilder();
        if(StrUtil.isNotEmpty(d)){
            str.append(d).append(".");
        }
        if(StrUtil.isNotEmpty(p)){
            str.append(p);
        }
        return str.toString();
    }



    @Override
    public String getSqlSegment(){
        boolean isOne=true;
        StringBuilder sql=new StringBuilder();
        if(CollUtil.isNotEmpty(this.select)){
            for(SelectBean sb:this.select){
                if(isOne){
                    isOne=false;
                    sql.append(this.getSelectItemSQL(sb));
                }else{
                    sql.append(" , ");
                    sql.append(this.getSelectItemSQL(sb));
                }
            }
        }
        return  sql.toString();
    }
}
