package com.xxh.cloud.web.common.task.constant;
/**
 * 任务
 * */
public enum TaskModuleEnum {

    // 同步互联网医院数据
    AllTask("allTask","执行全部任务"),

    // 同步互联网医院数据
    syncHisDeptTask("syncHisDeptTask","同步互联网医院科室信息"),
    syncHisDoctorTask("syncHisDoctorTask","同步互联网医院医生信息"),
    syncAllHisPatient("syncAllHisPatient","全量同步互联网医院家属信息"),
    syncHisPatient("syncHisPatient","增量同步互联网医院家属数据"),
    setSelfRelationTask("setSelfRelationTask","定时任务设置只有一个且未设置家属关系的家属为本人"),

    // 患者访问配置(黑名单)
    syncPatientRecordBlackList("syncPatientRecordBlackList","同步wbmd患者黑名单"),
    cacheVisitVerificationConfig("cacheVisitVerificationConfig","缓存访问校验配置表信息"),
    syncPatient4IdCard("syncPatient4IdCard","根据身份证扩展患者ID"),

    // 数据统计
    diagnosisPatient("diagnosisPatient","确证人数日统计"),
    potentialPatient("potentialPatient","潜在患者未就诊日统计"),
    patientFollowup("patientFollowup","复诊患者日统计表"),
    patientInpatientLoss("patientInpatientLoss","住院流失日统计"),
    firstDisease("firstDisease","首发病患者日统计"),

    ;
    private String code;
    private String msg;
    private TaskModuleEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }
    public String getCode() {
        return code;
    }
    public String getMsg() {
        return msg;
    }


}
