package com.xxh.cloud.framework.common.exception;


/**
 * 错误编码，由5位数字组成，前2位为模块编码，后3位为业务编码
 * <p>
 * 如：10001（10代表系统模块，001代表业务代码）
 * </p>
 */

public enum BusinessBaseErrorEnum implements IErrorCodeEnum {


    INTERNAL_SERVER_ERROR(500,"内部服务器错误"),

    UNAUTHORIZED(401,"未认证"),

    Not_Permission_Error(403,"无权限"),


    NOT_NULL(10001,"不能为空"),

    DB_RECORD_EXISTS(10002,"数据记录存在"),

    DB_RECORD_NOT_EXISTS(10003,"数据记录不存在"),
    PARAMS_GET_ERROR(10004,"获取参数错误"),

    Config_GET_ERROR(10005,"参数配置错误"),

    Illegal_Operation_ERROR ( 10006,"已上架不能操作"),

    Run_Rule_ERROR (10007,"执行规则引擎错误"),

    Password_Null_ERROE ( 10008,"密码不能为空"),

    Password_Security_Level_ERROE ( 10009,"密码安全级别不足"),

    DataSource_Config_ERROR(10010,"数据源配置错误"),



    Run_QL_ERROR (10011,"执行QL引擎错误"),

    Config_QL_ERROR (10012,"QL规则配置错误"),


    UpFile_ERROR(10101,"上传文件错误"),
    OpAuth_ERROR(10102,"无权限操作"),



//   IDENTIFIER_NOT_NULL ( 10006,""),
//
//   CAPTCHA_ERROR (10007,"验证码错误"),

//

//   PASSWORD_ERROR ( 10009,"密码错误"),

//   SUPERIOR_DEPT_ERROR ( 10011,"上级部门错误"),
//
//   SUPERIOR_MENU_ERROR ( 10012,"上级菜单错误"),

//   DATA_SCOPE_PARAMS_ERROR ( 10013,""),
//
//   DEPT_SUB_DELETE_ERROR ( 10014,"子部门删除错误"),
//
//   DEPT_USER_DELETE_ERROR ( 10015,""),
//
//   UPLOAD_FILE_EMPTY (10019,""),
//
//   TOKEN_NOT_EMPTY ( 10020,""),
//
//   TOKEN_INVALID ( 10021,""),
//
//   ACCOUNT_LOCK ( 10022,""),
//
//   OSS_UPLOAD_FILE_ERROR ( 10024,""),

   REDIS_ERROR ( 10027,"Redis错误"),


//
//   JOB_ERROR ( 10028,""),
   INVALID_SYMBOL ( 10029,"无效符号"),

    /** 签名错误*/
    SIGN_ERROR(-98,"签名错误"),
    /** 签名配置错误*/
    SIGN_Config_Error(-99,"签名配置错误"),
    ;
    private int code;
    private String msg;

    private BusinessBaseErrorEnum() {
    }

    BusinessBaseErrorEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    @Override
    public int getCode() {
        return code;
    }

    @Override
    public String getMsg() {
        return msg;
    }
}
