package com.xxh.cloud.framework.common.param.bos;

import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * 系统安全配置
 * App_Security
 * */
@Getter
@Setter
public class AppSysSecurityConfigBO {

    /**
     *  登录方式 : 同时登录 ， 单一登录
     * */
    private String singleLogin;


    /**
     *  超时登出 (分钟)
     * */
    private int tokenTimeout;


    /**
     * 密码错误次数
     * */
    private int passwordErrorsNumber;


    /**
     * 锁定用户分类(账号锁定 延时登录)
     * */
    private String lockType;

    /**
     * 延迟登录时间 （分钟）
     * */
    private  int lockTime;

    /**
     * 是否登录验证 (YN)
     * */
    private String enableLoginVerification;

    /**
     * 登录验证方式
     * */
    private String loginVerificationType;

    /**
     * 是否白名单验证（YN）
     * */
    private String enableWhitelist;

    /**
     * 白名单设置
     * */
    private List<String> whiteListIp;
}
