package com.xxh.cloud.framework.common.param.bos;

import com.xxh.cloud.framework.common.constant.ConfigDataTypeEnum;
import com.xxh.cloud.framework.common.constant.ElementInputTypeEnum;
import com.xxh.cloud.framework.common.constant.YN;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;


/**
 * 标准数据值定义配置
 * */
@Getter
@Setter
public class MetadataValueConfigBO {

    /**
     * key
     * */
    private String key;


    /**
     * 名称
     * */
    private String name;


    /**
     *  是否空(Y:不能为空, N:可空)
     * */
    private String notEmpty= YN.NO.getCode();

    /**
     * 输入分类(下拉框)[ElementInputTypeEnum]
     * */
    private String type= ElementInputTypeEnum.Text.getCode();


    /**
     * 数据配置: 数值最小值
     * */
    private Float numMin;

    /**
     * 数据配置: 数值最大值
     * */
    private Float numMax;

    /**
     * 数据配置: 数据格式
     * */
    private String dataFormat;

    /**
     * 数据配置:数组分类:[ConfigDataTypeEnum]
     * */
    private String listDataType;



    /**
     * 数据配置:数组配置1()
     * */
    private String listDataCfg;


    /**
     * 值
     * */
    private Object val;




}
