package com.xxh.cloud.framework.common.param.bos;

import com.xxh.cloud.framework.common.constant.DataScopeMode;
import com.xxh.cloud.framework.common.constant.UserRegLoginMode;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Value;

import java.util.List;

/**
 *  业务系统配置
 *  Project_Config
 * */
@Getter
@Setter
public class ProjectConfigBO {


    //============================运营端===========================================

    /**
     * 运营端:数据隔离模式 DataScopeMode
     * */
    private String sysDataScopeMode= DataScopeMode.TenantDataScope.getCode();

    /**
     *  运营端:支持用户登录方式 UserRegLoginMode
     * */
    public List<String> sysUserLoginMode;

    /**
     * 运营端:手机号是否必填 (YN)
     * */
    private String sysUserMobileIsNotNull;

    /**
     * 运营端:手机号是否唯一性验证 (YN)
     * */
    private String sysUserMobileIsSingle;



    //============================机构端===========================================
    /**
     * 机构端:数据隔离模式 DataScopeMode
     * */
    public String comUserDataScopeMode= DataScopeMode.TenantDataScope.getCode();

    /**
     *  机构端:支持用户登录方式 UserRegLoginMode
     * */
    public List<String> comUserLoginMode;

    /**
     * 机构端:手机号是否必填 (YN)
     * */
    private String comUserMobileIsNotNull;

    /**
     * 机构端:手机号是否唯一性验证 (YN)
     * */
    private String comUserMobileIsSingle;


    //===============================客户端==========================================

    /**
     * 客户端:
     * 客户用户数据隔离方式（机构数据隔离、租户数据隔离）
     * 机构数据隔离:注册和登录时机构编号不能为空
     * 租户数据隔离:注册和登录时不需要机构编号
     * */
    public String custUserDataScopeMode= DataScopeMode.TenantDataScope.getCode();


    /**
     *  客户端:用户登录方式
     * */
    public List<String> custUserLoginMode;


    /**
     * 客户端:  用户自主注册方式  UserRegLoginMode
     * */
    public List<String> custUserAppRegMode;








}
