package com.xxh.cloud.framework.common.param.bos;

import lombok.Getter;
import lombok.Setter;

/**
 * 微信配置
 * */
@Getter
@Setter
public class WxApiConfig {

    /**
     * 设置微信小程序的appid [Y]
     */
    private String appid;

    /**
     * 设置微信小程序的Secret [Y]
     */
    private String secret;


    /**
     * 设置微信小程序消息服务器配置的token [N]
     */
    private String token;

    /**
     * 设置微信小程序消息服务器配置的EncodingAESKey [N]
     */
    private String aesKey;

    /**
     * 消息格式，XML或者JSON [N]
     */
    private String msgDataFormat;

    /**
     * 授权作用域
     */
    private String scope;

    /**
     * 授权后重定向的回调链接地址，请使用urlencode对链接进行处理
     */
    private String redirectUri;

    /**
     * 应用agentid
     */
    private Long agentid;

}
