package com.xxh.cloud.framework.common.param.constant;

import com.xxh.cloud.framework.common.constant.IBizBaseEnum;

/**
 * 参数分类
 * */
public enum ParamTypeEnum implements IBizBaseEnum {

    SysParam("sys","系统参数"),
    BizParam("biz","业务参数"),

    SysParamList("sys_list","系统数组参数"),
    BizParamList("biz_list","业务数组参数"),

    ;
    private String code;
    private String name;

    private ParamTypeEnum() {
    }

    ParamTypeEnum(String code, String name) {
        this.code = code;
        this.name = name;
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getName() {
        return name;
    }


}
