package com.xxh.cloud.framework.common.param.constant;

import com.xxh.cloud.framework.common.constant.IBizBaseEnum;

/**
 * 参数值分类定义
 * */
public enum ParamValTypeEnum implements IBizBaseEnum {

    ValParam("val","普通值参数"),

    KeyValParam("key_val","Key—Val参数"),


    //email
    EmailParam("mail","邮箱配置参数"),

    //oss
    Ali_Oss("ali_oss","阿里云OSS配置参数"),

    Tencent_Oss("tencent_cos","腾讯云OSS配置参数"),

    File_local_Oss("file_local","本地文件存储配置参数"),

    Minio_oss("minio_oss","minio文件存储"),

    //sms
    Ali_Sms("ali_sms","阿里云短信配置参数"),

    Tencent_Sms("tencent_sms","腾讯云短信配置参数"),

    VCode_Sms("vcode_sms","短信验证码规则配置参数"),

    //weixin

    WX_MP_Third("wx_mp","微信公众号配置"),

    WX_Mini_Third("wx_mini","微信小程序配置"),

    WX_WORK_Third("wx_work","企业微信配置"),


    //pay
    Ali_Pay("ali_pay","支付宝支付配置参数"),

    WX_Pay("wx_pay","微信支付配置参数"),

    //login
    Cust_User_RegLogin("cust_reg_login","客户用户登录配置配置参数"),

    //
    AppSys_basic("app_sys_basic_cfg","系统基本配置"),

    AppSys_Security("app_sys_security_cfg","系统安全配置"),

    Project_Config("project_config","业务系统配置"),

    //
    MetadataValue_Config("meta_data_value_{}","标准数据数据类型配置"),

    ;
    private String code;
    private String name;

    private ParamValTypeEnum() {
    }

    ParamValTypeEnum(String code, String name) {
        this.code = code;
        this.name = name;
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getName() {
        return name;
    }

}
