package com.xxh.cloud.framework.common.ql;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ReUtil;
import cn.hutool.core.util.StrUtil;
import com.ql.util.express.Operator;

import java.net.SocketTimeoutException;

public class RegexOperator extends Operator {

    public RegexOperator(String aAliasName, String aName, String aErrorInfo) {
        this.name = aName;
        this.aliasName = aAliasName;
        this.errorInfo = aErrorInfo;
    }



    @Override
    public Object executeInner(Object[] list) throws Exception {
        String msg;

        if (list.length != 2){
            msg = "对象为空，不能执行方法:";
            throw new Exception(msg + this.name);
        }

        Object obj1 = list[0];
        Object obj2=list[1];

        if (obj1 == null || obj2 == null) {
            msg = "对象为空，不能执行方法:";
            throw new Exception(msg + this.name);
        }

        if (!(obj2 instanceof String)) {
            msg = "对象类型不匹配，只有字符串类型才才能执行正则操作,当前数据类型是:";
            throw new Exception(msg + obj2.getClass().getName());
        }

        String text=Convert.toStr(obj1);
        String regex=Convert.toStr(obj2);


        boolean flag = ReUtil.isMatch(regex, text);
        //System.out.println( StrUtil.format("+++++++ 内容: {}  正则表达式: {}  结果 : {} ",text,regex,flag));

        if(flag){
            return Boolean.TRUE;
        }else {
            return Boolean.FALSE;
        }
    }


}
