package com.xxh.cloud.framework.common.redis;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

public interface IBasicCacheService <T>{

    public T getById(String id);

    public Map<String,T> getMapByIds(Collection<String> ids);

    public List<T> getListByIds(Collection<String> ids);

    public void removeById(String id);

    public void removeByIds(Collection<String> ids);

    public Set<String> getCacheKeySet();

    public void removeAll();


}
