package com.xxh.cloud.framework.common.utils;

import cn.hutool.core.lang.Console;
import com.xxh.cloud.framework.common.config.BaseProjectConfig;


public class ConsoleUtils {


    private static boolean isPrint(){
        BaseProjectConfig baseProjectConfig= SpringContextUtils.getBean(BaseProjectConfig.class);
        if(baseProjectConfig==null){
            return false;
        }
        return baseProjectConfig.isPrint();
    }


    public static void log() {
        if(isPrint()){
            Console.log();
        }
    }

    public static void log(Object obj) {
        if(isPrint()){
            Console.log(obj);
        }
    }

    public static void log(Object obj, Object... otherObjs){
        if(isPrint()){
            Console.log(obj,otherObjs);
        }
    }

    public static void log(String template, Object... values){
        if(isPrint()){
            Console.log(template,values);
        }
    }

    public static void log(Throwable t, String template, Object... values) {
        if(isPrint()){
            Console.log(t,template,values);
        }
    }



}
