package com.xxh.cloud.framework.common.utils;

import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;

public class PasswordCheckUtils {

    //数字
    private static final String REG_NUMBER = ".*\\d+.*";
    //小写字母
    private static final String REG_UPPERCASE = ".*[A-Z]+.*";
    //大写字母
    private static final String REG_LOWERCASE = ".*[a-z]+.*";
    //特殊符号
    private static final String REG_SYMBOL = ".*[~!@#$%^&*()_+|<>,.?/:;'\\[\\]{}\"]+.*";


    public static void validatePassword(String password){
        if(StrUtil.isEmpty(password)){
            throw new BusinessException(BusinessBaseErrorEnum.Password_Null_ERROE);
        }
        boolean flag= checkPassword(password);
        if(!flag){
            throw new BusinessException(BusinessBaseErrorEnum.Password_Security_Level_ERROE);
        }
    }

    public static boolean checkPassword(String password){
        // 密码8位以上
        if (StrUtil.isEmpty(password) || password.length() < 8){
            return false;
        }
        int i = 0;
        if (password.matches(REG_NUMBER)) i++;
        if (password.matches(REG_LOWERCASE)) i++;
        if (password.matches(REG_UPPERCASE)) i++;
        if (password.matches(REG_SYMBOL)) i++;
        if (i  < 3 )  {
            return false;
        } else {
            return true;
        }
    }

//    public static void main(String[] args) {
//
//        System.out.println(PasswordCheckUtils.checkPassword("20@333333"));
//    }


}
