package com.xxh.cloud.framework.common.utils;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;

import java.util.*;

public class StrJoinSplitUtils {


    public static String join(Collection<String> strs){
        return join(strs,",");
    }

    public static String join(Collection<String> strs,String conjunction){
        if(CollUtil.isEmpty(strs)){
            return null;
        }
        if(StrUtil.isEmpty(conjunction)){
            conjunction=",";
        }
        String data= CollUtil.join(strs,conjunction);
        return data;
    }

    public static List<String> split2List(String strs){
        return split2List(strs,",");
    }

    public static List<String> split2List(String strs,String conjunction){
        if(StrUtil.isEmpty(strs)){
            return new ArrayList<>();
        }
        if(StrUtil.isEmpty(conjunction)){
            conjunction=",";
        }
        if (strs.startsWith(conjunction)) {
            strs = strs.substring(1);
        }
        List<String> data = CollUtil.newArrayList(strs.split(conjunction));
        return data;
    }

    public static Set<String> split2Set(String strs){
        return split2Set(strs,",");
    }

    public static Set<String> split2Set(String strs,String conjunction){
        if(StrUtil.isEmpty(strs)){
            return new HashSet<>();
        }
        if(StrUtil.isEmpty(conjunction)){
            conjunction=",";
        }
        if (strs.startsWith(conjunction)) {
            strs = strs.substring(1);
        }
        Set<String> data= CollUtil.newHashSet(strs.split(conjunction));
        return data;
    }

    public static String joinPrefix(Collection<String> strs) {
        return joinPrefix(strs, ",");
    }

    public static String joinPrefix(Collection<String> strs, String conjunction) {
        strs.removeIf(i -> null == i);
        String join = join(strs, conjunction);
        if (StrUtil.isNotEmpty(join)) {
            return conjunction + join + conjunction;
        } else {
            return join;
        }
    }
}
