package com.xxh.cloud.framework.common.utils;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.EnumUtil;
import cn.hutool.core.util.ReflectUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.constant.IBizBaseEnum;
import com.xxh.cloud.framework.common.constant.UserRegLoginMode;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class XXEnumUtil {


    public static <E extends Enum<E>> Map<String, E> getEnumMap(final Class<E> enumClass){
        return XXEnumUtil.getEnumMap(enumClass,"code");
    }


//    public static <E extends Enum<E>> List<E> getEnumList(final Class<E> enumClass){
//        return XXEnumUtil.getEnumMap(enumClass,"code");
//    }


    public static <E extends Enum<E>> E getEnum(final Class<E> enumClass,String fieldVal){
        if(StrUtil.isEmpty(fieldVal)){
            return null;
        }
        Map<String,E> map=getEnumMap(enumClass);
        E data=map.get(fieldVal);
        return data;
    }

    public static <E extends Enum<E>> E getEnum(final Class<E> enumClass,String fieldName,String fieldVal){
        Map<String,E> map=getEnumMap(enumClass,fieldName);
        E data=map.get(fieldVal);
        return data;
    }

    public static <E extends Enum<E>> Map<String, E> getEnumMap(final Class<E> enumClass, String fieldName) {
        final Map<String, E> map = new HashMap<>();
        for (final E e : enumClass.getEnumConstants()) {
            map.put(Convert.toStr(ReflectUtil.getFieldValue(e, fieldName)), e);
        }
        return map;
    }


    public static <E extends Enum<E>> List<E> getEnumList(final Class<E> enumClass) {
        final List<E> list = new ArrayList<>();
        for (final E e : enumClass.getEnumConstants()) {
            list.add(e);
        }
        return list;
    }



}
