/**
 * Copyright (c) 2018 人人开源 All rights reserved.
 *
 * https://www.renren.io
 *
 * 版权所有，侵权必究！
 */

package com.xxh.cloud.framework.common.validator;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.xss.SqlFilterUtils;
import javassist.expr.Instanceof;

import javax.validation.ConstraintViolation;
import javax.validation.Validation;
import javax.validation.Validator;
import java.util.Map;
import java.util.Set;

/**
 * hibernate-validator校验工具类
 * 参考文档：http://docs.jboss.org/hibernate/validator/6.0/reference/en-US/html_single/
 */
public class ValidatorUtils {

    /**
     * 校验对象
     * @param object        待校验对象
     * @param groups        待校验的组
     */
    public static void validateEntity(Object object, Class<?>... groups) throws BusinessException {
        Validator validator =Validation.buildDefaultValidatorFactory().getValidator();
        Set<ConstraintViolation<Object>> constraintViolations = validator.validate(object, groups);
        if (!constraintViolations.isEmpty()) {
        	ConstraintViolation<Object> constraint = constraintViolations.iterator().next();
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR.getCode(), constraint.getMessage());
        }
        if(object==null){
            return;
        }
        // Map<String,Object> beanMap= BeanUtil.beanToMap(object);
        // for(String key:beanMap.keySet()){
        //     Object keyVal=beanMap.get(key);
        //     ValidatorUtils.validateSQL(keyVal);
        // }
    }



    public static void validateSQL(Object val){
        if(val ==null ){
            return;
        }
        if(val instanceof String){
            String str=(String) val;
            SqlFilterUtils.sqlInject(str);
        }
    }








}