package com.xxh.cloud.framework.common.write2;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.framework.common.write.bean.HwdsWriteDBConfigBean;
import org.apache.commons.lang3.StringUtils;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Collections;
import java.util.List;
import java.util.Map;

public class DorisWriteUtils {


    public static JdbcBatchWriteDTO batchWrite(DataSource dataSource,HwdsWriteDBConfigBean writeDBConfig, List<Map<String, Object>> data) {
        if(CollUtil.isEmpty(data)){
            return new JdbcBatchWriteDTO(true,0);
        }
        int num= data.size();
        try {
            batchWriteVoid(dataSource,writeDBConfig,data);
            return new JdbcBatchWriteDTO(true, num);
        }catch (Exception e){
            return new JdbcBatchWriteDTO(false, num,e.getMessage());
        }
    }


    public static void batchWriteVoid(DataSource dataSource, HwdsWriteDBConfigBean writeDBConfig, List<Map<String, Object>> data){
        String tableName =writeDBConfig.getTable();
        List<String> fieldNames = StrJoinSplitUtils.split2List(writeDBConfig.getColumn());
        String sqlInsert =DorisWriteUtils.getSqlInsert(tableName,fieldNames);
        System.out.println(sqlInsert);

        try (Connection connection = dataSource.getConnection(); PreparedStatement ps = connection.prepareStatement(sqlInsert); ) {
            connection.setAutoCommit(false);
            for (Map<String,Object> recordValue : data) {
                for (int j = 0; j < fieldNames.size(); j++) {
                    ps.setObject(j + 1, recordValue.get(fieldNames.get(j)));
                }
                ps.addBatch();
            }
            ps.executeBatch();
            ps.clearBatch();
            connection.commit();
        } catch (SQLException se) {
            throw new RuntimeException(se);
        }
    }


    public static String getSqlInsert(String tableName, List<String> fieldNames){
        String sqlInsert = String.format("INSERT INTO %s ( %s ) VALUES ( %s )", tableName,
                StringUtils.join(fieldNames, ","),
                StringUtils.join(Collections.nCopies(fieldNames.size(), "?"), ","));
        return sqlInsert;
    }


}
